#!/bin/gawk -f
# we need gawk for gensub and match
# 
BEGIN {directory ="distrib/" }

function alph (num) {
  return substr("abcdefghijklmnopqrstuvwxyz", num, 1)
}

/begin[[:space:]]*{figure/ { infigure=1; figure++; subfigure=0; linebuf="" }

/includegraphics/ { subfigure++; 
   match($0, /(\\includegraphics[[:space:]]*(\[[^]]*\]))?{([a-zA-Z_0-9]+.eps)}/, grafikbefehl)
   myfigname = grafikbefehl[3]
   system("cp " myfigname " " directory  "subfig_" figure alph(subfigure) ".eps") 
   
   linebuf = linebuf gensub (/(\\includegraphics[[:space:]]*(\[[^]]*\]))?{([a-zA-Z_0-9]+.eps)}/, "\\1{subfig_" figure alph(subfigure) ".eps}", 1) "\n"
   next }

infigure { linebuf = linebuf $0 "\n" }  

!infigure 

/end[[:space:]]*{figure/  { 
   # Sonderfall: Nur eine Subfigure
   if (subfigure==1) { 
     printf "%s", gensub (/(\\includegraphics[[:space:]]*(\[[^]]*\]))?{([a-zA-Z_0-9]+.eps)}/, "\\1{fig_" figure ".eps}", 1, linebuf) 
     system("mv " directory "subfig_" figure alph(subfigure) ".eps " directory "fig_" figure  ".eps")
   } else { 
      printf "%s", linebuf 
    }

    infigure=0
   }
END {
  # Kopieren der BIBTEX-Liste
  #
  bblname=FILENAME
  sub(/\.tex$/, ".bbl", bblname)
  system ("cp " bblname "  " directory)
}  
